2013-06-10 13:28:47 +04:00
#!/usr/bin/env bash
2017-06-29 11:38:06 +03:00
# Copyright (C) 2011-2017 Red Hat, Inc. All rights reserved.
2011-01-05 03:16:18 +03:00
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License v.2.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
2016-01-21 13:49:46 +03:00
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
2011-01-05 03:16:18 +03:00
2015-10-27 17:08:43 +03:00
initskip( ) {
2017-06-29 11:38:06 +03:00
test " $# " -eq 0 || echo "TEST SKIPPED: " " $@ "
2015-10-27 17:08:43 +03:00
exit 200
}
2011-01-05 03:16:18 +03:00
# sanitize the environment
LANG = C
LC_ALL = C
TZ = UTC
2012-03-16 16:59:43 +04:00
# Put script name into variable, so it can used in external scripts
TESTNAME = ${ 0 ##*/ }
# Nice debug message
2012-03-20 14:51:57 +04:00
PS4 = '#${BASH_SOURCE[0]##*/}:${LINENO}+ '
2012-03-16 16:59:43 +04:00
export TESTNAME PS4
2015-10-26 22:09:47 +03:00
if test -n " $LVM_TEST_FLAVOUR " ; then
2017-06-29 11:38:06 +03:00
. " lib/flavour- $LVM_TEST_FLAVOUR "
2015-10-26 22:09:47 +03:00
fi
2015-10-27 17:08:43 +03:00
test -n " $SKIP_WITHOUT_CLVMD " && test " $LVM_TEST_LOCKING " -ne 3 && initskip
test -n " $SKIP_WITH_CLVMD " && test " $LVM_TEST_LOCKING " -eq 3 && initskip
2015-10-26 22:09:47 +03:00
2015-10-27 17:08:43 +03:00
test -n " $SKIP_WITHOUT_LVMETAD " && test -z " $LVM_TEST_LVMETAD " && initskip
test -n " $SKIP_WITH_LVMETAD " && test -n " $LVM_TEST_LVMETAD " && initskip
test -n " $SKIP_WITH_LVMPOLLD " && test -n " $LVM_TEST_LVMPOLLD " && initskip
2016-02-23 01:13:42 +03:00
test -n " $SKIP_WITH_LVMLOCKD " && test -n " $LVM_TEST_LVMLOCKD " && initskip
2015-10-27 17:08:43 +03:00
unset CDPATH
# grab some common utilities
. lib/utils
2015-10-26 22:09:47 +03:00
2012-03-16 16:59:43 +04:00
TESTOLDPWD = $( pwd )
2011-06-30 04:57:29 +04:00
COMMON_PREFIX = "LVMTEST"
PREFIX = " ${ COMMON_PREFIX } $$ "
2011-01-05 03:16:18 +03:00
2015-10-06 15:55:24 +03:00
# Check we are not conflickting with some exiting setup
2015-10-09 22:30:37 +03:00
dmsetup table | not grep " ${ PREFIX } [^0-9] " || die " DM table already has devices with prefix $PREFIX ! "
2015-10-06 15:55:24 +03:00
2015-02-12 12:33:48 +03:00
if test -z " $LVM_TEST_DIR " ; then LVM_TEST_DIR = $TMPDIR ; fi
2014-06-28 01:16:49 +04:00
TESTDIR = $( mkdtemp " ${ LVM_TEST_DIR :- /tmp } " " $PREFIX .XXXXXXXXXX " ) || \
2012-03-20 14:51:57 +04:00
die " failed to create temporary directory in ${ LVM_TEST_DIR :- $TESTOLDPWD } "
2015-04-29 14:37:13 +03:00
RUNNING_DMEVENTD = $( pgrep dmeventd || true )
2011-01-05 03:16:18 +03:00
2012-03-16 16:59:43 +04:00
export TESTOLDPWD TESTDIR COMMON_PREFIX PREFIX RUNNING_DMEVENTD
2015-04-20 11:05:27 +03:00
export LVM_LOG_FILE_EPOCH = DEBUG
2016-07-11 13:43:28 +03:00
export LVM_LOG_FILE_MAX_LINES = 100000
2015-04-20 20:16:33 +03:00
export LVM_EXPECTED_EXIT_STATUS = 1
2011-01-05 03:16:18 +03:00
2012-03-16 16:59:43 +04:00
test -n " $BASH " && trap 'set +vx; STACKTRACE; set -vx' ERR
2011-01-05 03:16:18 +03:00
trap 'aux teardown' EXIT # don't forget to clean up
2013-08-23 12:06:14 +04:00
cd " $TESTDIR "
2014-06-27 02:58:28 +04:00
mkdir lib
# Setting up symlink from $i to $TESTDIR/lib
test -n " $abs_top_builddir " && \
find " $abs_top_builddir /daemons/dmeventd/plugins/ " -name '*.so' \
-exec ln -s -t lib "{}" +
find " $TESTOLDPWD /lib " ! \( -name '*.sh' -o -name '*.[cdo]' \
-o -name '*~' \) -exec ln -s -t lib "{}" +
2013-08-23 12:06:14 +04:00
2014-06-05 14:09:02 +04:00
DM_DEFAULT_NAME_MANGLING_MODE = none
2012-03-16 16:59:43 +04:00
DM_DEV_DIR = " $TESTDIR /dev "
LVM_SYSTEM_DIR = " $TESTDIR /etc "
2017-02-21 11:38:49 +03:00
# abort on the internal dm errors in the tests (allowing test user override)
DM_ABORT_ON_INTERNAL_ERRORS = ${ DM_ABORT_ON_INTERNAL_ERRORS :- 1 }
export DM_DEFAULT_NAME_MANGLING_MODE DM_DEV_DIR LVM_SYSTEM_DIR DM_ABORT_ON_INTERNAL_ERRORS
2014-06-27 02:58:28 +04:00
mkdir " $LVM_SYSTEM_DIR " " $DM_DEV_DIR "
2011-09-25 00:54:35 +04:00
if test -n " $LVM_TEST_DEVDIR " ; then
2015-05-04 11:15:56 +03:00
test -d " $LVM_TEST_DEVDIR " || die " Test device directory LVM_TEST_DEVDIR=\" $LVM_TEST_DEVDIR \" is not valid. "
2012-03-16 16:59:43 +04:00
DM_DEV_DIR = $LVM_TEST_DEVDIR
2011-09-25 00:54:35 +04:00
else
2015-04-29 14:37:13 +03:00
mknod " $DM_DEV_DIR /testnull " c 1 3 || die "mknod failed"
2012-03-16 16:59:43 +04:00
echo >" $DM_DEV_DIR /testnull " || \
die " Filesystem does support devices in $DM_DEV_DIR (mounted with nodev?) "
2017-02-21 11:38:49 +03:00
# dmsetup makes here needed control entry if still missing
dmsetup version || \
die " Dmsetup in $DM_DEV_DIR can't report version? "
2011-09-25 00:54:35 +04:00
fi
2011-01-05 03:16:18 +03:00
2012-03-16 16:59:43 +04:00
echo " $TESTNAME " >TESTNAME
2011-01-05 03:16:18 +03:00
2014-03-04 19:24:44 +04:00
echo " Kernel is $( uname -a) "
2014-03-02 22:15:52 +04:00
# Report SELinux mode
2015-04-29 14:37:13 +03:00
echo " Selinux mode is $( getenforce 2>/dev/null || echo not installed) . "
2015-05-01 16:37:50 +03:00
free -m || true
2014-03-02 22:15:52 +04:00
2012-03-16 16:59:43 +04:00
# Set vars from utils now that we have TESTDIR/PREFIX/...
prepare_test_vars
test -n " $BASH " && set -eE -o pipefail
2011-01-05 03:16:18 +03:00
2015-04-15 15:31:28 +03:00
# Vars for harness
echo " @TESTDIR= $TESTDIR "
echo " @PREFIX= $PREFIX "
2015-04-14 10:47:14 +03:00
if test -n " $LVM_TEST_LVMETAD " ; then
2012-03-16 16:59:43 +04:00
export LVM_LVMETAD_SOCKET = " $TESTDIR /lvmetad.socket "
2013-11-30 00:56:29 +04:00
export LVM_LVMETAD_PIDFILE = " $TESTDIR /lvmetad.pid "
2014-01-24 18:59:38 +04:00
aux prepare_lvmetad
2015-04-14 10:47:14 +03:00
else
# lvmetad prepares its own lvmconf
2016-03-15 01:16:45 +03:00
export LVM_LVMETAD_PIDFILE = " $TESTDIR /non-existing-file "
2015-04-14 10:47:14 +03:00
aux lvmconf
aux prepare_clvmd
fi
2014-03-02 22:15:52 +04:00
2015-05-09 02:59:18 +03:00
test -n " $LVM_TEST_LVMPOLLD " && {
export LVM_LVMPOLLD_SOCKET = " $TESTDIR /lvmpolld.socket "
export LVM_LVMPOLLD_PIDFILE = " $TESTDIR /lvmpolld.pid "
aux prepare_lvmpolld
}
2015-03-05 23:00:44 +03:00
if test -n " $LVM_TEST_LVMLOCKD " ; then
if test -n " $LVM_TEST_LOCK_TYPE_SANLOCK " ; then
aux lvmconf 'local/host_id = 1'
fi
2016-02-23 22:58:22 +03:00
2015-03-05 23:00:44 +03:00
export SHARED = "--shared"
fi
2016-02-23 22:58:22 +03:00
# for check_lvmlockd_test, lvmlockd is restarted for each shell test.
# for check_lvmlockd_{sanlock,dlm}, lvmlockd is started once by
# aa-lvmlockd-{sanlock,dlm}-prepare.sh and left running for all shell tests.
if test -n " $LVM_TEST_LVMLOCKD_TEST " ; then
aux prepare_lvmlockd
fi
2015-04-13 17:30:17 +03:00
echo " <======== Processing test: \" $TESTNAME \" ========> "
2011-01-05 03:16:18 +03:00
set -vx